package jpmapper.core;

import java.util.HashMap;

import jpmapper.config.DBInformation;
import jpmapper.database.MySqlMapper;

/**
 * @author Dahhane walid , mindware.ma
 * @version 0.7.1
 */
public class DBMapperFactory {

	private HashMap<String,AbstractDBMapper> dbmsMappers;
	private static DBMapperFactory instance;

	private DBMapperFactory(){

	}
	DBInformation dbInformation;
	private DBMapperFactory(DBInformation dbInformation){
		this.dbInformation=dbInformation;
		dbmsMappers=new HashMap<String,AbstractDBMapper>();
		MySqlMapper mySqlMapper=MySqlMapper.getInstance(dbInformation,false);
		dbmsMappers.put("mysql", mySqlMapper);
	}

	public void finalize() throws Throwable {

	}

	/**
	 * 
	 * @param DBMS
	 * @return ADBMSMapper
	 */
	public AbstractDBMapper getDBMSMapper(String DBMS){
		return this.dbmsMappers.get(DBMS);
	}
	
	
	public AbstractDBMapper getTDBMSMapper(String DBMS) {
	 if(DBMS.equalsIgnoreCase("mysql")){
		 return MySqlMapper.getInstance(dbInformation,false);
	 }
	return null;
	}

	/**
	 * 
	 * @param dbInformation
	 */
	public static DBMapperFactory getInstance(DBInformation dbInformation,boolean isSingleton){
			if(!isSingleton||instance==null)instance=new DBMapperFactory(dbInformation);
			return instance;
		}

}