package jpmapper.core;

import java.sql.ResultSet;
import java.sql.SQLException;

import jpmapper.exceptions.CRUDWarningException;
import jpmapper.exceptions.JPMapperException;
import jpmapper.exceptions.LockWaitTimeoutException;
import jpmapper.exceptions.TransactionInitBeginException;

public class Transaction extends JPMapperFacade{
	
	
	Transaction(String configFilePath){
		super(configFilePath,true);
	}
	private AbstractDBMapper dbmsMapper;

	public void begin(){
		try {
			
			this.dbmsMapper=this.dbmsMapperFactory.getTDBMSMapper(dbInformation.getDbms());
			this.dbmsMapper.connect(this.getDbInformation().getHost(), this.getDbInformation().getPort(), this.getDbInformation().getDbName(), this.getDbInformation().getDbUser(), this.getDbInformation().getDbPassword(),false);
		} catch (JPMapperException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	public int delete(Object object,String where) throws LockWaitTimeoutException, SQLException{
			if(this.dbmsMapper==null)
				try {
					throw new  TransactionInitBeginException("Transaction not began:"+this.toString());
				} catch (TransactionInitBeginException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				try {
					int i=0;
					if(( i=this.dbmsMapper.delete(object, where))>0)
					return i;
					else
							throw new CRUDWarningException("Warning: 0 Row deleted");
				} catch (CRUDWarningException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				return 0;
	}
	
	public Object getObject(){
		
		return null;
	}
	
		
	public boolean put(Object object){
		if(this.dbmsMapper==null)
			try {
				throw new  TransactionInitBeginException("Transaction not began:"+this.toString());
			} catch (TransactionInitBeginException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
				try {;
					//add sub-objects
					//this.dbmsMapper.insert(object);
					//add Object
					this.dbmsMapper.insert(object);
					return true;
				} catch (JPMapperException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				return false;
			
	}	
	
	public int update(Object object,String where){
		if(this.dbmsMapper==null)
			try {
				throw new  TransactionInitBeginException("Transaction not began:"+this.toString());
			} catch (TransactionInitBeginException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
				try {
					int i=0;
					if(( i=this.dbmsMapper.update(object, where))>0)
					return i;
					else
						try {
							throw new CRUDWarningException("Warning: 0 Row deleted");
						} catch (CRUDWarningException e) {
							// TODO Auto-generated catch block
							return 0;
						}
				} catch (JPMapperException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			return -1;
	
	}
	
	public boolean execute(String sqlQuery){
		if(this.dbmsMapper==null)
			try {
				throw new  TransactionInitBeginException("Transaction not began:"+this.toString());
			} catch (TransactionInitBeginException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
				try {
					return this.dbmsMapper.execute(sqlQuery);
				} catch (JPMapperException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			return false;
	}
	
	public int executeUpdate(String sqlQuery){

				try {
					return this.dbmsMapper.executeUpdate(sqlQuery);
				} catch (JPMapperException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			return -1;
	}
	
	/**
	 * <p>
     * This method should be run in transactional mode
     * </p>
	 * @param sqlQuery
	 * @return ResultSet
	 * 
	 */
	public ResultSet executeQuery(String sqlQuery){
		if(this.dbmsMapper==null)
			try {
				throw new  TransactionInitBeginException("Transaction not began:"+this.toString());
			} catch (TransactionInitBeginException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
				try {
					return this.dbmsMapper.executeQuery(sqlQuery);
				} catch (JPMapperException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	
	return null;
	}
	
	public long getNextAutoIncrement(Object object){
		if(this.dbmsMapper==null)
			try {
				throw new  TransactionInitBeginException("Transaction not began:"+this.toString());
			} catch (TransactionInitBeginException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
				try {
					return this.dbmsMapper.getNextAutoIncrement(object);
				} catch (JPMapperException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			return -1;
	}
	public void end(){
		this.dbmsMapper.commit();
	}
	
	public void rollback(){
		this.dbmsMapper.rollback();
	}

}
